<?php

require_once "class.ldap_im.inc.php";
require_once "class.db_im.inc.php"; 

class contacts_im
{
	private $ldap;
	private $db_user;
	
	function __construct()
	{
		$this->ldap = new ldap_im();
		$this->db_user = new db_im();		
	}

	private function users_auth_im()
	{
		$db_acls = $this->db_user->get_accounts_acl();
		
		$search_uids = "|";
		foreach($db_acls as $tmp)
			$search_uids .= "(uidNumber=".$tmp['acl_account'].")";

		// Busca Usuarios
		$uids = $this->ldap->list_users_ldap($search_uids);
		
		$search_groups = "|";
		foreach($db_acls as $tmp)
			$search_groups .= "(gidNumber=".$tmp['acl_account'].")";
		
		// Busca Grupos
		$groups = $this->ldap->list_groups_ldap($search_groups);
		
		$search_uids = "|";
		foreach($groups as $tmp){
			$members = $tmp['members'];	
			foreach($members as $mb)		
				$search_uids .= "(uid=".$mb.")";			
		}
		
		$uids_members = $this->ldap->list_users_ldap($search_uids);
		
		foreach($uids_members as $tmp)
			$uids[] = $tmp;
		
		return $uids; 
		
	}
		
	function list_contacts($param)
	{
		$users = $this->users_auth_im();
		$ordenar = array();
		$return = array();
		$i = 0;
		
		foreach($users as $tmp)
			$ordenar[] = $tmp['cn'].";".$tmp['mail'].";".$tmp['uid'].";".$tmp['dn'];
					
		natsort($ordenar);
		$uid_unique = @array_values(@array_unique($ordenar));
		
		foreach($uid_unique as $tmp){	
			$result = explode(";",$tmp);
			if($result[3] == $param['ou']){
				$return[$i]['cn']   = $result[0];
				$return[$i]['mail'] = $result[1];
				$return[$i]['uid']  = $result[2];
				$i++;
			}
			unset($result);
		}			
		
		if(count($return) > 0)
			return $return;
		else
			return 0;
	}
}
?>