<?php
define('PHPGW_INCLUDE_ROOT','../');	
define('PHPGW_API_INC','../phpgwapi/inc');
require_once(PHPGW_API_INC.'/class.db.inc.php');
	
class db_im
{	
	
	var $db;
	var $db_name;
	var $db_host;
	var $db_port;
	var $db_user;
	var $db_pass;
	var $db_type;
	
	function db_im(){
		$this->db_name = $_SESSION['phpgw_info']['instant_messenger']['server']['db_name'];
		$this->db_host = $_SESSION['phpgw_info']['instant_messenger']['server']['db_host'];
		$this->db_port = $_SESSION['phpgw_info']['instant_messenger']['server']['db_port'];
		$this->db_user = $_SESSION['phpgw_info']['instant_messenger']['server']['db_user'];
		$this->db_pass = $_SESSION['phpgw_info']['instant_messenger']['server']['db_pass'];
		$this->db_type = $_SESSION['phpgw_info']['instant_messenger']['server']['db_type'];
		
		$this->db = new db();		
		$this->db->connect($this->db_name,$this->db_host,$this->db_port,$this->db_user,$this->db_pass,$this->db_type);
	}

	function get_contacts_im($pFrom = false, $pTo)
	{		
		$result = array();
 		$from = explode("/",$pFrom);
 		$to = explode("/",$pTo);
 		if($pFrom)
 			$query = "select im_from, im_to from phpgw_im_auth_user where im_from = '".$from[0]."' and im_to = '".$to[0]."'";
		else
			$query = "select im_from, im_to from phpgw_im_auth_user where im_to = '".$to[0]."' order by im_from"; 			
        
        if (!$this->db->query($query))
        	return null;
		
		while($this->db->next_record())
			$result[] = $this->db->row();

		return $result;
	}
	
	function insert_contacts($pFrom, $pTo)
	{
		$from = explode("/",$pFrom);
 		$to = explode("/",$pTo);
		$query = "insert into phpgw_im_auth_user values('".$from[0]."','".$to[0]."')";
		return $this->query_db($query);		
	}
	
	function delete_contacts($pFrom, $pTo)
	{
		$from = explode("/",$pFrom);
 		$to = explode("/",$pTo);
		$query = "delete from phpgw_im_auth_user where im_from = '".$from[0]."' and im_to = '".$to[0]."'";
		return $this->query_db($query);
	}
	
	function get_accounts_acl()
	{
		$result = array();
		$query = "select acl_appname, acl_account from phpgw_acl where acl_appname = 'instant_messenger' order by acl_account";	
 		
 		if (!$this->db->query($query))
        	return null;
		
		while($this->db->next_record())
			$result[] = $this->db->row();

		return $result;
	}
	
	function query_db($pQuery)
	{
		if (!$this->db->query($pQuery))
        	return false;
		else
			return true;
	}
	
	function set_preferences($param)
	{
		$preferences = $param['preferences'];
		$user_id  = $_SESSION['phpgw_info']['instant_messenger']['user_id']; 
		$app_name = "instant_messenger";

		$query = "insert into phpgw_preferences values('".$user_id."','".$app_name."','".serialize($preferences)."')";
		
		if($this->query_db($query)){ 
			return 1;
		}else{
			//$query = "insert into phpgw_preferences values('".$user_id."','".$app_name."','".serialize($preferences)."')";
			$query = "update phpgw_preferences set preference_value = '".serialize($preferences)."' where preference_app='".$app_name."' and preference_owner='".$user_id."'";
			if($this->query_db($query))
				return 1;
			else
				return 0;			
		}		
	}
	
	function get_preferences()
	{
		$result = array();
		$user_id  = $_SESSION['phpgw_info']['instant_messenger']['user_id'];
		$app_name = "instant_messenger";
		
		$query = "select * from phpgw_preferences where preference_owner = '".$user_id."' and preference_app = '".$app_name."'";
		
 		if (!$this->db->query($query))
        	return NULL;
		
		while($this->db->next_record())
			$result[] = $this->db->row();

		if(count($result) > 0)
			return unserialize($result[0]['preference_value']);
		else
			return "ch_time:true;ch_offline:true;ch_contacts:true;rd_nm:true;rd_al:false;rd_ch:false";
		
	}
}
?>