// Instant Messenger
// im_preferences.js

	function Preferences()
	{
		this.save_vcard = "";	
	}

   /*
	* Add
	*/
	
	Preferences.prototype.Add_userLoad = function()
	{
		Templates.add_user();
		this.SearchOrganizationsLdap();
		var select_contact = document.getElementById('ImSelAddContact');
		select_contact.innerHTML = "";
	}
	
	Preferences.prototype.SearchOrganizationsLdap = function()
	{
		var handler_organizations = function(data){
			var select_org = document.getElementById('ImSelOrg');
			if(select_org.options.length > 0)
				select_org.options.splice(0,select_org.options.length);
			var options = new Option("--Selecione -- ", -1, false, true);
			select_org[select_org.length] = options;
			
			for(var i in data){
				var options = new Option(data[i], data[i], false, true);
				select_org[select_org.length] = options;
			}
			select_org[0].selected = true;
		}
		cIM.cExecute("$this.ldap_im.list_organizations_ldap", handler_organizations);
	}
	
	Preferences.prototype.SearchContacts = function()
	{
		var select_org = document.getElementById('ImSelOrg');
		var select_contact = document.getElementById('ImSelAddContact');
		var organization = "";
		var span_load = document.getElementById('_span_load_im');
			span_load.style.visibility = "visible";
				
		for(var i=0; i < select_org.options.length; i++){
			if(select_org.options[i].selected == true){
				organization = select_org.options[i].value;
			}
		}
		var handler_contacts = function(data){
			var select_contact = document.getElementById('ImSelAddContact');
			var text0 = document.getElementById('text0');
			var text1 = document.getElementById('text1');
			var content = "";
			select_contact.innerHTML = "";
			text0.value = "";
			text1.value = "";
			
			if( data.length > 0 ){
				for(var i in data){
					if(data[i].cn != ""){
						var options =  new Option(data[i].cn + " ( "+ data[i].mail + " )", data[i].mail + ";" + data[i].uid, false, false);
						select_contact[select_contact.length] = options;
					}
				}
			}

			span_load.style.visibility = "hidden";		
		}
		cIM.cExecute("$this.contacts_im.list_contacts", handler_contacts,"ou="+organization);
	
	}

	Preferences.prototype.preenche = function()
	{
		var select = document.getElementById('ImSelAddContact');
		if(select.options.length > 0){
			for(var i=0; i < select.options.length; i++){
				if(select.options[i].selected == true){
					var email = select.options[i].value.substr(0,select.options[i].value.indexOf(';'));
					var uid = select.options[i].value.substr((select.options[i].value.indexOf(';')+1),select.options[i].value.length);
					document.getElementById('text0').value = email;
					document.getElementById('text1').value = email.substr(0,email.indexOf('@'));	
					document.getElementById('text2').focus(); 			
					document.getElementById('text3').value = uid;
				}
			}
		}
	}
	
	Preferences.prototype.Add_user = function(pFunc)
	{
		var text0 = document.getElementById('text0');
		var text1 = document.getElementById('text1');
		var text2 = document.getElementById('text2');
		var text3 = (document.getElementById('text3') != null) ? document.getElementById('text3') : false ;
		
		var _this = this;
		var jid   = text0.value;
		var subscription = "";

		if(func.trim(text0.value) != "" && func.trim(text1.value) != "" && func.trim(text2.value) != ""){
			var handler_add_contact = function(data){
				if(data){
					text0.value = "";
					text1.value = "";
					text2.value = "";	
					if(pFunc != 'divAddUser_im')
						im_win.windowClose(pFunc);
					IM.UpdateContacts();
					_this.Refresh_Screen(jid);
				}
			}
			var name = url_encode(encodeURI(text1.value));
			var group = url_encode(encodeURI(text2.value));
			if(pFunc == 'divAddUser_im')
				subscription = "none";
			else
				subscription = "to";
			if(text3)
				var email = text3.value + "@" + text0.value.substr((text0.value.indexOf('@')+1),text0.value.length);
			else
				var email = text0.value;
			cIM.cExecute("$this.Ujabber.AddNewContacts",handler_add_contact,"email="+email+"&name="+name+"&group="+group+"&subscription="+subscription);
		}else{
			alert("Informe todos os campos!");
		}
	}

   /*
	* Remove
	*/
	
	Preferences.prototype.Remove_userLoad = function()
	{
		Templates.remove_user();
		var sel_contact = document.getElementById('sel_contact');
		if(sel_contact.options.length > 0)
			sel_contact.options.splice(0,sel_contact.options.length);
		var opt = new Option("-- "+IM.get_lang('Choice Contact')+" -- ","0",true,true);
		sel_contact.options[sel_contact.length] = opt;

		for(var i=1; i < IM.array_users.length; i++){
			if(decodeURI(IM.array_users[i].name) != ""){
				opt = new Option(decodeURI(IM.array_users[i].name),IM.array_users[i].jid, false, false);
				sel_contact.options[sel_contact.length] = opt;
			}else{
				name = IM.array_users[i].jid.substr(0,IM.array_users[i].jid.indexOf('@'));
				opt = new Option(name,IM.array_users[i].jid, false, false);
				sel_contact.options[sel_contact.length] = opt;
			}
		}
	}
	
	Preferences.prototype.Remove_user = function()
	{
		var _this = this;
		var sel_contact = document.getElementById('sel_contact');
		for(var i=0; i < sel_contact.options.length; i++){
			if(sel_contact[i].selected && sel_contact.options[i].value != 0){
				if(confirm("Excluir o contato " + sel_contact.options[i].innerHTML + "?")){
					var in_el = sel_contact.options[i].innerHTML;
					for(var j=1 ; j < IM.array_users.length; j++){
						var name = IM.array_users[j].jid.substr(0,IM.array_users[j].jid.indexOf('@'));
						if(decodeURI(IM.array_users[j].name) == in_el || name == in_el){
							var handler_remove_contact = function(data){
								if(!data){
									alert(data);
									return false;
								}
	  						    setTimeout("IM.UpdateContacts()",1000);
							}
							cIM.cExecute("$this.Ujabber.RosterRemoveUser",handler_remove_contact,"jid="+sel_contact.options[i].value);
							IM.array_users.splice(j,1);
							_this.ComboRemove();							
							j--;
						}
					}
				}
			}
		}
	}
	
	Preferences.prototype.ComboRemove = function()
	{
		var sel_contact = document.getElementById('sel_contact');
		if(sel_contact.length > 0 ){
			for(var i=0; i < sel_contact.options.length; i++){
				sel_contact.options[i] = null;
				i--;
			}
		}

		var opt = new Option("-- "+IM.get_lang('Choice Contact')+" -- ","0",true,true);
		sel_contact.options[sel_contact.length] = opt;
		for(var i=1; i < IM.array_users.length; i++){
			opt = new Option(decodeURI(IM.array_users[i].name),IM.array_users[i].jid, false, false);
			sel_contact.options[sel_contact.length] = opt;
		}
	}	

	Preferences.prototype.Remove_Contact = function(pJid)
	{
		var _this = this;
		for(var i=0; i < IM.array_users.length; i++){
			if(IM.array_users[i].jid == pJid){
				if(confirm("Excluir o contato " + decodeURI(IM.array_users[i].name) + "?")){
					var handler_remove_contact = function(data){
						if(!data){
							alert(data);
							return;
						}else{
  						    _this.Refresh_Screen(pJid);  						    
  						    IM.UpdateContacts();
						}
					}
					cIM.cExecute("$this.Ujabber.RosterRemoveUser",handler_remove_contact,"jid="+pJid);
				}	
				return;
			}	
		}
	}

   /*
    * Update
    */
   
   Preferences.prototype.updateLoad = function(pJid)
   {
   		Jid = pJid;
   		Templates.update_user();   	
   		document.getElementById('text0').value = Jid;
   		document.getElementById('span0').innerHTML = Jid.substr(0,Jid.indexOf('@'));
   }
   
   Preferences.prototype.Update_ = function(pJid,pType)
   {
		var name  = "";
		var group = "";
		var jid   = pJid;
		
		for(var i=1; i < IM.array_users.length; i++){
			if(IM.array_users[i].jid == pJid){
				name  = decodeURI(IM.array_users[i].name);
				group = decodeURI(IM.array_users[i].group);
			}
		}
		
		if((name != "") && (group != "")){
			if(pType){
				var act = prompt("Digite um apelido para :" + pJid , name);
				name = url_encode(encodeURI(act));
				group = url_encode(encodeURI(group));
			}else{
				var act = prompt("Digite um novo grupo para : " + name, group);
				group = url_encode(encodeURI(act));
				name = url_encode(encodeURI(name));
			}				
			if((act != null) && (act != "")){
				var handler_update_contacts = function(data){
					if(data)
						IM.UpdateContacts();
					else
						alert("erro");
				}				
				cIM.cExecute("$this.Ujabber.UpdateUser",handler_update_contacts,"jid="+jid+"&name="+name+"&group="+group);
			}
		}
	}

	Preferences.prototype.Update_Group = function(pJid)
	{
		this.Update_(pJid,false);		
	}
		
	Preferences.prototype.Update_NickName = function(pJid)
	{
		this.Update_(pJid,true);   
	}
   
   /*
	* Vcard
	*/
		
	Preferences.prototype.vCardLoad = function()
	{
		Templates.information_user();
		document.getElementById('FN').value = IM.vcard_user['VCARD_FN'];
		document.getElementById('NICKNAME').value = IM.vcard_user['VCARD_NICKNAME'];
		document.getElementById('ORGNAME').value = IM.vcard_user['VCARD_ORGNAME'];
		document.getElementById('ORGUNIT').value = IM.vcard_user['VCARD_ORGUNIT'];
		document.getElementById('ROLE').value = IM.vcard_user['VCARD_ROLE'];
		document.getElementById('BDAY').value = IM.vcard_user['VCARD_BDAY'];
		document.getElementById('DESC').value = IM.vcard_user['VCARD_DESC'];
	}
	
	Preferences.prototype.vCardAdd = function()
	{
		var _this = this;
		IM.vcard_user['VCARD_FN'] = document.getElementById('FN').value;
		_this.save_vcard = url_encode(encodeURI(document.getElementById('FN').value)) + ";";
		IM.vcard_user['VCARD_NICKNAME'] = document.getElementById('NICKNAME').value;
		_this.save_vcard += url_encode(encodeURI(document.getElementById('NICKNAME').value)) + ";";
		var nickname = document.getElementById('span_nickname').innerHTML;
		document.getElementById('span_nickname').innerHTML = (IM.vcard_user['VCARD_NICKNAME']) ? "<b>&nbsp;" + IM.vcard_user['VCARD_NICKNAME'].substring(0,30) + "</b>" : nickname;
		IM.vcard_user['VCARD_ORGNAME'] = document.getElementById('ORGNAME').value;
		_this.save_vcard += url_encode(encodeURI(document.getElementById('ORGNAME').value)) + ";";
		IM.vcard_user['VCARD_ORGUNIT'] = document.getElementById('ORGUNIT').value;
		_this.save_vcard += url_encode(encodeURI(document.getElementById('ORGUNIT').value)) + ";";
		IM.vcard_user['VCARD_ROLE'] = document.getElementById('ROLE').value;
		_this.save_vcard += url_encode(encodeURI(document.getElementById('ROLE').value)) + ";";
		IM.vcard_user['VCARD_BDAY'] = document.getElementById('BDAY').value;
		_this.save_vcard += url_encode(encodeURI(document.getElementById('BDAY').value)) + ";";		
		IM.vcard_user['VCARD_DESC'] = document.getElementById('DESC').value;
		_this.save_vcard += url_encode(encodeURI(document.getElementById('DESC').value));		
		var message_desc = document.getElementById('span_message').innerHTML;
		document.getElementById('span_message').innerHTML = (IM.vcard_user['VCARD_DESC']) ? "<b>&nbsp;" + IM.vcard_user['VCARD_DESC'].substring(0,30) + "</b>" : message_desc ;

		var handler_vcardAdd = function(data){
			if(!data)
				alert(data);
			else
				alert("Informaes Cadastradas / Atualizadas !");
		}
		cIM.cExecute("$this.Ujabber.newVcard",handler_vcardAdd,"vcard="+_this.save_vcard);
	}
	
	Preferences.prototype.vCardLoad_Contact = function(pJid)
	{
		Templates.information_Contact();
		for(var i=0; i < IM.array_users.length; i++){
			if(IM.array_users[i].jid == pJid){
				document.getElementById('_lbl_FN').innerHTML = decodeURI(IM.array_users[i].VCARD_FN);
				document.getElementById('_lbl_Nickname').innerHTML = decodeURI(IM.array_users[i].VCARD_NICKNAME);
				document.getElementById('_lbl_Orgunit').innerHTML = decodeURI(IM.array_users[i].VCARD_ORGUNIT);
				document.getElementById('_lbl_Role').innerHTML = decodeURI(IM.array_users[i].VCARD_ROLE);
				document.getElementById('_lbl_Birthday').innerHTML = decodeURI(IM.array_users[i].VCARD_BDAY);																
				return;
			}	
		}
	}

   /*
	*  Detalhes do Contato para Autorizao
	*/
	
	Preferences.prototype.Info_Contact = function(pJid)
	{
		var element = "_span_not_" + pJid;
		var pElement = "teste";
		var uid = pJid.substr(0,pJid.indexOf('@'));

		var handler_ldap =  function(data){

			if(data){
				var form_details = '<table cellpadding="0" cellspacing="0" style="background-color:#cbdae4;width:80%;border:1px solid #809aa9">' +
								   '<tr><td style="vertical-align:top;width:80%">' +
								   '<div style="padding-bottom">' + 
								   '<span><label>'+IM.get_lang('Name')+'</label></br>'+ data[0].cn + '</span></br></br>' +
								   '<span><label>'+IM.get_lang('E-mail')+'</label></br>'+ data[0].mail + '</span></br>' +							    
								   '</div></td>' +
								   '<td style="vertical-align:top"><img id="' + pJid + '_avatar" src="' + img_photo.src + '" style="height:65px;width:60px;align:right">' +	
								   '</td></tr>'+
								   '</table>';	
		
				im_menu_action.menu(element, form_details);
		
				// Foto Ldap;
				im_win.get_photo_ldap(pJid);
			}
		}
		cIM.cExecute("$this.ldap_im.info_user",handler_ldap,"uid="+uid);
	
	
	}
	
   /*
    * Envio de arquivo
    */
    
    Preferences.prototype.SendFile = function(pJid)
    {
		if(im_send_file == 'true'){
			Templates.Send_file(pJid);
		}else{
			alert('Funo Indisponvel!');
		}
    }
    
    Preferences.prototype.SizeFile = function()
    {
    	var h_SizeFile = function(data){
    		alert(data);	
    	}
 	   	cIM.cExecute("$this.upload.size_file",h_SizeFile);
    }
	
   /*
	* Preferncias do Usurio
	*/

	Preferences.prototype.yourPreferences = function()
	{
		Templates.yourPreferences();
		if( IM.array_prefe['sizeof'] > 0 ){
			document.getElementById('ch_time').checked = eval(IM.array_prefe['ch_time']);
			document.getElementById('ch_offline').checked = eval(IM.array_prefe['ch_offline']);
			document.getElementById('ch_contacts').checked = eval(IM.array_prefe['ch_contacts']);
			document.getElementById('rd_nm').checked = eval(IM.array_prefe['rd_nm']);
			document.getElementById('rd_al').checked = eval(IM.array_prefe['rd_al']);
			document.getElementById('rd_ch').checked = eval(IM.array_prefe['rd_ch']);												
		}else{
			this.GetPreferences();
		}
		
	}
	
	Preferences.prototype.SetPreferences = function()
	{
		var EcheckBox = new Array();
			EcheckBox[0] = 'ch_time';
			EcheckBox[1] = 'ch_offline';
			EcheckBox[2] = 'ch_contacts';
		var Eradio = new Array()
			Eradio[0] =	'rd_nm';
			Eradio[1] = 'rd_al';
			Eradio[2] =	'rd_ch';				
		var preferences = '';
		var _this = this;
		
		for(var i in EcheckBox){
			if(document.getElementById(EcheckBox[i]).checked){
				preferences += EcheckBox[i] + ':' + true + ';';
				IM.array_prefe[EcheckBox[i]] = true;
			}else{
				preferences += EcheckBox[i] + ':' + false + ';';
				IM.array_prefe[EcheckBox[i]] = false;				
			}
			IM.array_prefe['sizeof'] = i;
		}
		
		for(var i in Eradio){
			if(document.getElementById(Eradio[i]).checked){
				preferences += Eradio[i] + ':' + true + ';';
				IM.array_prefe[Eradio[i]] = true;				
			}else{
				preferences += Eradio[i] + ':' + false + ';';
				IM.array_prefe[Eradio[i]] = false;				
			}
			IM.array_prefe['sizeof'] = IM.array_prefe['sizeof'] = i + 1;
		}
		
		var handler_set_preferences = function(data)
		{
			if(data)
				alert('Preferncias cadastradas com sucesso!');
			IM.ContactsOffline();				
		}
		cIM.cExecute("$this.db_im.set_preferences",handler_set_preferences,"preferences="+preferences);

	}
	
	Preferences.prototype.GetPreferences = function()
	{
		var handler_get_preferences = function(data){
			var opt =  data.split(";");
			for(var i in opt){
				if(opt[i] != ""){
					var el = opt[i].split(":");
					if(document.getElementById(el[0]) != null){
						var id_el = document.getElementById(el[0]);
							id_el.checked = eval(el[1]);
					}
					IM.array_prefe[el[0]] = eval(el[1]);
					IM.array_prefe['sizeof'] = i;
				}
			}
		}
		cIM.cExecute("$this.db_im.get_preferences",handler_get_preferences);

	}
	
   /*
    * Tela de permisso para novos contatos
    */	

	Preferences.prototype.Refresh_Screen = function(pJid)
	{
		var el_tbl = document.getElementById("_cell_" + pJid);
		if(el_tbl != null)	
		   el_tbl.parentNode.removeChild(el_tbl);
	}
    
// Build Object	
	var Preferences = new Preferences();	